#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
#include	"kawkfunc.h"
#include	"ksysprot.h"
#define		SHOWCODE
#undef		SHOWCODE
#define		SYMPRT
#undef		SYMPRT
#define		PRTTXT
#undef		PRTTXT
/*
============================================================
	function to show code as executed or compiled
============================================================
*/
#ifdef	SHOWCODE
typedef	struct	VDB	{
	INST	fa;
	char	*fn;
	}	VDB;
VDB	vdb[] = {
(INST) xarray, "xarray",
(INST) xassgn, "xassgn",
(INST) xbreak, "xbreak",
(INST) xbwand, "xbwand",
(INST) xbwio, "xbwio",
(INST) xbwleft, "xbwleft",
(INST) xbwright, "xbwright",
(INST) xbwxo, "xbwxo",
(INST) xcc, "xcc",
(INST) xcd, "xcd",
(INST) xconst, "xconst",
(INST) xcontinue, "xcontinue",
(INST) xdd, "xdd",
(INST) xdohone, "xdohone",
(INST) xdohtwo, "xdohtwo",
(INST) xdolone, "xdolone",
(INST) xdoltwo, "xdoltwo",
(INST) xdtoi, "xdtoi",
(INST) xdtol, "xdtol",
(INST) xecute, "xecute",
(INST) xek, "xek",
(INST) xeval, "xeval",
(INST) xex, "xex",
(INST) xfeof, "xfeof",
(INST) xff, "xff",
(INST) xfor, "xfor",
(INST) xfunc, "xfunc",
(INST) xgo, "xgo",
(INST) xif, "xif",
(INST) xitod, "xitod",
(INST) xkey, "xkey",
(INST) xland, "xland",
(INST) xlinenum, "xlinenum",
(INST) xlneg, "xlneg",
(INST) xlor, "xlor",
(INST) xonec, "xonec",
(INST) xpoint, "xpoint",
(INST) xqu, "xqu",
(INST) xquest, "xquest",
(INST) xrs, "xrs",
(INST) xsf, "xsf",
(INST) xsp, "xsp",
(INST) xss, "xss",
(INST) xstack, "xstack",
(INST) xstart, "xstart",
(INST) xsu, "xsu",
(INST) xsym, "xsym",
(INST) xte, "xte",
(INST) xtf, "xtf",
(INST) xti, "xti",
(INST) xum, "xum",
(INST) xvk, "xvk",
(INST) xvv, "xvv",
(INST) xwhat, "xwhat",
(INST) xwhile, "xwhile",
(INST) 0, "XSTOP",
	}	;
showcode(ip)
INST	*ip;
{
	auto	VDB		*vdx = vdb;
	auto	INST	ipx;
	ipx = *ip;
	while(ipx != (INST) 0 && vdx->fa != (INST) 0)	{
		if(ipx == vdx->fa)	{
			fprintf(stderr,"code[%u] ",ip -prg);
			fprintf(stderr,"%lu %s\n",vdx->fa,vdx->fn);
			break;
			}
		vdx += 1;
		}
	return(ZERO);
}
#else
showcode(ip)
INST	*ip;
{
	notimp("showcode");
	return(ZERO);
}
#endif
#ifdef	SYMPRT
SYMBOL	*
prtasym(fp,stx)
FILE	*fp;
SYMBOL	*stx;
{
	fprintf(fp,
	"sym(%u) nm(%s) ty(%c) es(%u) ts(%u) adr(%u) off(%u)\n",
	stx,stx->name,stx->type,stx->esize,stx->tsize,stx->adr,stx->off);
	switch(stx->type)	{
		case	'c':	
			fprintf(stderr,"%c %o",stx->type,*(int *) stx->off);
		when	'd':	
			fprintf(stderr,"%c %d",stx->type,*(double *) stx->off);
		when	'i':	
			fprintf(stderr,"%c %d",stx->type,*(int *) stx->off);
		when	's':
			fprintf(stderr,"%c %s",stx->type,stx->off);
		when	VKED:	
			fprintf(stderr,"%c %s",stx->type,stx->off);
						break;
		default:		fprintf(stderr,"?");
		}
	fprintf(stderr,"\n");
	return(stx);
}
SYMBOL	*
prtabif(fp,fu)
FILE	*fp;
FUNCP	fu;
{
	auto	SYMBOL	*stx = sbase;
	while(stx != NULL)	{
		if(stx->adr == fu)	{
			prtasym(fp,stx);
			return(stx);
			}
		stx = stx->snext;
		}
	fprintf(fp,"prtabif: fu(%u)\n",fu);
	return(NULL);
}
SYMBOL	*
prtsym(fp)
FILE	*fp;
{
	auto	SYMBOL	*stx = sbase;
	while(stx != NULL)	{
		prtasym(fp,stx);
		stx = stx->snext;
		}
	return(NULL);
}
#else
SYMBOL	*
prtasym(){}
SYMBOL	*
prtsym(){}
#endif
#ifdef	PRTTXT
prttxt(os,is)
char	*os;
char	*is;
{
	auto	char	*isx = is;
	fprintf(stderr,"%10.10s ",os);
	fputs("==>",stderr);
	while(*isx != ZERO && *isx != LF)	putc(*isx++,stderr);
	fputs("<==\n",stderr);
	return(ZERO);
}
#endif
