#define		DUMP		/* core dump on errors */
#undef		DUMP
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	<signal.h>
/**/
#define		ALLOCATE
#include	"ksyskref.h"
/**/
#define		WORKFILE	"/krXXXXXX.tmp"
/*GLOBAL*/
char	*tmpdir;
/*EXTERN*/
extern char *rdpara();
extern void doselect();
/**/
char	*nfmsg = NULL;		/* not found message */
char	*fnmsg = NULL;		/* found message */
char	*texpr = NULL;		/* target expression */
/**/
void
cleanup()
{
	unlink(wfn);
	return;
}
void
terror(ty)
int		ty;
{
	cleanup();
	errmsg("terror(%u)\n",ty);
	query(stderr);
#ifdef	DUMP
	abort();
#endif	/*DUMP*/
	exit(ty);
	return;
}
main(argc,argv)
int		argc;
char	*argv[];
{
	if(cmderr(argc,argv,"BCCDFIMPRSTWabcefhjlmnorstu0123456789"))
		exit(FUBAR);
	kenv.dosdos = isdos();
/**/
	disnme(kenv.pname = "kref");
/**/
	cmdxrc(argc,argv,kref,"kref.xrc");
	return(0);	/* LINT */
}
kref(argc,argv)
int		argc;
char	*argv[];
{
	auto	char	*wfb = NULL;
	auto	char	*ofb = NULL;
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else	{
		telluser(kenv.pname);
		disrec(YES);
		}
/**/
	kenv.blockd = cmdnum(argc,argv,'P',4,4) * bufsiz();
/**/
	if(isatty(1))	{
		kenv.leisur = baudrate(stdout) >= 1200 ? DA | DB : 0;
		kenv.leisur = cmdnum(argc,argv,'l',kenv.leisur,DA|DB);
		kenv.folder = cmdnum(argc,argv,'f',56,56);
	}
/**/
	if(cmdnum(argc,argv,'W',0,1))	{
		whoru(stdout);
		exit(0);
		}
/**/
	if(cmdnum(argc,argv,'h',0,DA))	{
		if(isatty(1))	{
			whoru(stdout);
			query(stdout);
			}
		exit(hint(ZERO));
		}
/**/
	bufrset(cmdnum(argc,argv,'C',4096,4096));
	bullset(cmdnum(argc,argv,'B',BLKSIZ,BLKSIZ));
/**/
	texpr = cmdstr(argc,argv,'e',kgetenv("KREFEXPR"));
/**/
	tmpdir = kgetenv("TMPDIR");
	if(isnull(tmpdir))	tmpdir = strsave(kenv.dosdos ? "." : "/usr/tmp");
	else				tmpdir = strsave(tmpdir);
	strcpy(wfn,tmpdir);
	strcat(wfn,WORKFILE);
	if(maketemp(wfn) != wfn)				terror(FUBAR);
	if(!(int) (wfp = efopen(wfn,"w+")))		terror(FUBAR);
#ifdef	SYSV
	wfb = ksetvbuf(wfp,wfb,_IOFBF,bufsiz());
#endif	/*SYSV*/
/**/
	text_list = cmdlist(argc,argv,'t',kgetenv("TEXTLIST"));
	if(cmdnum(argc,argv,'t',0,0) == 1)	text_list = blkrd(text_list);
	bibl_list = cmdlist(argc,argv,'b',kgetenv("BIBLLIST"));
	if(cmdnum(argc,argv,'b',0,0) == 1)	bibl_list = blkrd(bibl_list);
	if(bibl_list)	{
		strxty(bibl_list,LF,' ');
		strcnd(bibl_list);
		}
	if(text_list)	{
		strxty(text_list,LF,' ');
		strcnd(text_list);
		}
/**/
	kenv.report = cmdnum(argc,argv,'R',0,DA|DB|DC);
	kenv.timing = cmdnum(argc,argv,'T',0,DA|DB|DC|DD|DE|DF);
	kenv.diagno = cmdnum(argc,argv,'D',0,DA|DB|DC|DD|DE|DF);
	kenv.flags2 = cmdnum(argc,argv,'a',DA|DB|DC,DD);
	kenv.flags3 = cmdnum(argc,argv,'u',DA|DB,DA|DB);
	kenv.buffer = cmdnum(argc,argv,'n',0,DA);
/**/
	kenv.flags0 |= cmdnum(argc,argv,'r',0,DA);
	kenv.flags0 |= cmdnum(argc,argv,'j',0,DB|DC);
	kenv.flags0 |= cmdnum(argc,argv,'m',0,DC);
	kenv.flags0 |= cmdnum(argc,argv,'c',0,DC|DD);
/**/
	nfmsg = cmdstr(argc,argv,'N',"not found");
	fnmsg = cmdstr(argc,argv,'F',"found");
/**/
/*	default to 0 on p until this improved */
	setbss(cmdstr(argc,argv,'I',".bs"));
	setmrk(cmdstr(argc,argv,'M',".BS:.BE:.BT"));
/**/
	if(signal(SIGINT,SIG_IGN) != SIG_IGN)	{
		signal(SIGINT,terror);
		fuset( (FUNCP) terror );
#ifdef	__TURBOC__
#else
		signal(SIGHUP,terror);

#endif	/*__TURBOC__*/
		}
/**/
	{
	auto	char	*ofn = cmdstr(argc,argv,'o',kgetenv("KREFOUT"));
	if(!isnull(ofn))	{
		if(!freopen(ofn,"w",stdout))	{
			prterr(ofn);
			exit(FUBAR);
			}
		kenv.leisur = 0;
		}
	}
	if(cmdnum(argc,argv,'c',0,1))	{
		kenv.flags1 = cmdnum(argc,argv,'c',DA|DB,DA|DB);
		docom();
		}
	else
	if(kenv.flags4 = cmdnum(argc,argv,'e',0,1))	{
		auto	char	*list = bibl_list ? bibl_list : text_list;
		if(isnull(list))	{
			list = cmdlist(argc,argv,ZERO,NULL);
			}
		if(isnull(list))	{
			errmsg("bsexpr <no file list>\n");
			terror(FUBAR);
			}
		if(kenv.flags4 == 1)	rdfunc = xrdcd;
		else
		if(kenv.flags4 == 2)	rdfunc = fgetlf;
		else
		if(kenv.flags4 == 3)	rdfunc = rdpara;
		else					{
			errmsg("<illegal value for -eN option>\n");
			terror(FUBAR);
			}
		kenv.flags1 = cmdnum(argc,argv,'s',DA|DB|DC|DD,DA|DB|DC|DD);
		bsexpr( texpr );			/* compile expression(s) */
		fileloop(list,doaexpr);	/* do file sweep */
		}
	else
	if(cmdnum(argc,argv,'s',0,1))	{
		if(kenv.flags0)	{
			errmsg("<-r, -j, -m options illegal with -s>\n");
			exit(FUBAR);
			}
		kenv.flags1 = cmdnum(argc,argv,'s',DB|DC|DE,DA|DC|DE);
		dobatch();
		}
	else
	if(cmdnum(argc,argv,'S',0,1))	{
		kenv.flags0 = kenv.flags2 = kenv.flags3 = 0;
		doselect();
		}
	else	{
		errmsg("<no operating mode specified>\n");
		}
/**/
	ofb = free_if(ofb);
	wfb = free_if(wfb);
/**/
	exit(0);
	return(0);	/* LINT */
}
void
docom()
{
	fileloop(text_list,dotfile);
	wfp = stdout;
	dobibl(bibl_list,addcom);
	return;
}
void
doselect()		/* not used items */
{
	extern	int		reject();
	fileloop(text_list,dotfile);
	dobibl(bibl_list,reject);
	return;
}
void
dobatch()		/* used items */
{
	fileloop(text_list,dotfile);
	dobibl(bibl_list,addwork);
	fileloop(text_list,retfile);
	if(kenv.flags3 & DA)	savework(NULL);
	else					unlink(wfn);
	return;
}
char 	*
rdpara()
{
	errmsg("<paragraph mode not yet implemented: use kwik>\n");
	terror(FUBAR);
	return(NULL);
}
