#define		DEBUG
#undef		DEBUG
#ifdef		DEBUG
#else		/*DEBUG*/
#endif		/*DEBUG*/
/*
	89:01:25 rewritten to use bsearch
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	"ksyskwik.h"
/**/
#define		F_NOCOM		0	/* no common word file */
#define		F_USCOM		1	/* use default file */
#define		F_USFIL		2	/* use specified file */
#define		F_USLST		4	/* use list of files */
#define		F_ZFILE		"zaplist.xrc"
#define		MAXWORDS	256
/**/
/*EXTERN*/
/*STATIC*/
static	char	*wordlist[MAXWORDS];
static	char	*wordbase;
static	NOSIGN	numwords;
/**/
/*EXTERNAL*/
/**/
qstrcmp(os,is)
char	**os;
char	**is;
{
	register	char	*osx = *os;
	register	char	*isx = *is;
#ifdef		DEBUG
	if(kenv.diagno)	fprintf(stderr,"qstrcmp(%s,%s) ",osx,isx);
#else		/*DEBUG*/
#endif		/*DEBUG*/
	while(*osx != 0 && *osx == *isx)	++osx, ++isx;
#ifdef		DEBUG
	if(kenv.diagno)	fprintf(stderr,"qstrcmp(%s,%s) ",osx,isx);
	if(kenv.diagno)	fprintf(stderr,"\n");
#else		/*DEBUG*/
#endif		/*DEBUG*/
	return(*osx - *isx);
}
showlist(fp)
FILE	*fp;
{
	auto	NOSIGN	ix;
	for(ix = 0; ix < numwords; ix++)	{
		if(ix % 6 == 0)	fprintf(fp,"\n");
		fprintf(fp,"%10.10s ",wordlist[ix]);
		}
	fprintf(fp,"\n");
	return(numwords);
}
buildlist(is)	/* build list of words to be rejected */
char	*is;
{
	auto	NOSIGN	added = 0;
	auto	char	*zaplist = "zaplist.xrc";
	auto	char	*list;
/**/
	extern	char	*findfile();
/**/
	if(isnull(is))	is = zaplist;
/**/
	wordbase = free_if(wordbase);
/**/
	list = findfile(is,1,".");
	if(isnull(list))	list = findfile(is,1,kgetenv("HOME"));
	else
	if(isnull(list))	list = findfile(is,1,kgetenv("PUBKIN"));
	if(isnull(list) || access(list,04))
			return(kenv.flags7 = added);
/**/
	wordbase = blkrd(list);
	list = free_if( list );
/**/
	strlwr(wordbase);
	numwords = splitc(wordlist,MAXWORDS,wordbase,LF);
/**/
	qsort( (char *) wordlist, numwords, sizeof(char *), qstrcmp);
/**/
	return(kenv.flags7 = DA);
}
iscommon(is)		/* does _is have a common word */
char	*is;
{
/*
	bsearch requires a (char **) as the first parameter. since
	&ws is ignored, the shit[0] = ws construct is used.
*/
	auto	char	ws[FNMSIZ];
	auto	char	*isx = is;
	auto	char	*shit[1];
	shit[0] = ws;
	strcnd(is);
	while((int) (isx = xgnc(ws,ws+FNMSIZ-1,isx,' ')))	{
	if(bsearch((char *) shit,(char *) wordlist,numwords,
		sizeof(char *),qstrcmp)) {
			errmsg("<excluded word> %s\n",ws);
			return(1);
		}
	}
	return(0);
}
infilter(is)		/* link to kwhash routines */
char	*is;
{
#ifdef	DEBUG
	auto	int		ret;
	ret = bsearch(&is,(char *) wordlist,numwords,sizeof(char *),qstrcmp);
	if(ret)	fprintf(stderr,"X %s\n",is);
#endif	/*DEBUG*/
	return(bsearch(&is,(char *) wordlist,numwords,sizeof(char *),qstrcmp));
}
