/*
**	default variable values
*/
/*START*/
#define		ABSO	'a'
#define		DC2		'\''
#define		DCC		'.'
#define		DFM		6
#define		DFN		1
#define		DFS		'f'
#define		DHM		6
#define		DHP		0
#define		DHS		10				/* chars per inch */
#define		DHY		8
#define		DIN		0
#define		DLL		60
#define		DLS		1
#define		DLT		60
#define		DPI		5
#define		DPL		66
#define		DPX		5
#define		DPD		1
#define		DPN		1
#define		DPO		0
#define		DQC		'?'
#define		DSV		22
#define		DTI		0
#define		DVP		0
#define		DVS		6				/* lines per inch */
#define		HORZ	'h'
#define		VERT	'v'
/*STOP*/
#define		WOFF	0				/* rel pos of word offset */
#define		WLEN	1				/* rel pos of word length */
#define		WTXT	2				/* rel pos of text */
#define		NENV	3
#define		HUGE	9999
#define     BASE    255
#define		LWORK	BUFSIZ			/* basic line size */
#define		MWORK	(BUFSIZ/2)		/* medium scratch */
#define		SWORK	(BUFSIZ/4)		/* small scratch, file names */
/*
**	internal control codes
*/
#ifdef		ESC
#undef		ESC
#endif
#define		ESC		'\134'		/* escape */
#define		ZRO		'\034'		/* zero width char */
#define		ZSP		'\032'		/* no pad space */
#define		WORD	'\027'		/* word indicator */
#define		VRV		'\026'		/* reverse line feed */
#define		FOU		'\025'		/* underline font */
#define		STOP	'\023'		/* stop */
#define		FOR		'\022'		/* roman font */
#define		THP		'\021'		/* tentative hyphen */
#define		FOP		'\020'		/* previous font */
#define		DWN		'\017'		/* down (no column change) */
#define		VUP		'\016'		/* half line up */
#define		BSP		'\010'		/* back space */
#define		FOI		'\005'		/* italics || underline font */
#define		VDO		'\004'		/* half line down */
#define		ITP		'\003'		/* interrupt processing */
#define		FOB		'\002'		/* bold font */
/*
**			convenience items
*/
#ifndef		when
#define		when	break;case
#endif
#ifndef		REG
#define		REG		register
#endif
/*
**			pseudo functions 
*/
#define     isfont(x)((x==FOB||x==FOR||x==FOU||x==FOI)?x:0)
#ifndef		isnull
#define		isnull(x)((x==NULL||*x==NULL)?1:0)
#endif
#ifndef		ZERO
#define		ZERO	0
#endif
/**/
#define		kase(x)((x[0] + (x[1] << 8)))
#ifdef		CECC
#define		KASE(x,y)case((('x' + ('y' << 8))))
#else
#define		KASE(x,y)case((x | (y << 8)))
#endif
/*
**			character width
*/
#define		pwc(a)(((a>=' '&&a<='~')||a==ZSP)?1:((a == '\b')?-1:0))
#undef		pwc
#define		pwc(a)((a >= ' ' || a == ZSP) ? 1 :((a == '\b')? -1 : 0 ))
/*
**			math function defines
*/
#define		NIC		'i'
#define		NIP		'I'
#define		NREGS		64		/* number of named registers */
