#define		KSYS_VTYPES_H
/*
	machine-specific definitions go here
*/
typedef		unsigned	char	UCHAR;
typedef		unsigned	int		NOSIGN;
typedef		unsigned	short	USHORT;
typedef		int		(*FUNCP)();		/* generic function pointer */
typedef		void	(*FUNCS)();		/* signal handling function ptr */
/*
	FUNCP is a pointer to a function.  this varies in size according
	to memory models.  NULLs must be case with this to avoid bombing.
*/
/*
	BASIC CARD STRUCTURE
*/
typedef	struct		KARD	{
	char	*skey;	/* int key */
	char	*lkey;	/* long key */
	char	*label;	/* label */
	char	*data;	/* data */
	int	flags;	/* flags */
}	KARD;
/*
	BUFFER BOOKKEEPING STRUCTURE
*/
typedef	struct		KBUF	{
	char	*base;
	char	*used;
	char	*bmax;
	int		bsize;
	int		nfld;
}	KBUF;
typedef		struct	KENV	{
	int		blockd;		/* blocking factor for setvbuf */
	int		buffer;		/* buffer size output */
	int		diagno;		/* diagnostic level */
	int		dosdos;		/* is MSDOS */
	int		folder;		/* fold point */
	int		hashed;		/* hasing on */
	int		isterm;		/* output is term */
	int		keying;		/* keyed input/output */
	int		leisur;		/* slow output */
	int		ndexed;		/* indexed */
	int		prompt;		/* is program interactive */
	int		record;		/* record output */
	int		report;		/* report level */
	int		screen;		/* lines on screen */
	int		slines;		/* lines output */
	int		talarm;		/* time for alarm */
	int		timing;		/* execution timing */
	int		tracer;		/* tracing */
	int		flags0;
	int		flags1;
	int		flags2;
	int		flags3;
	int		flags4;
	int		flags5;
	int		flags6;
	int		flags7;
	FILE		*cfptr;		/* current file ptr */
	FILE		*ofptr;		/* output file ptr */
	FILE		*ifptr;		/* input file ptr */
	char		*cfnme;		/* current file name */
	char		*ofnme;		/* output file name */
	char		*ifnme;		/* input file name */
	char		*pname;		/* program name */
}	KENV;
