/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		NUMARG		512		/* max number of arguments */
#define		MAXARG		5120	/* size of arg block */
/*EXTERN*/
#ifdef	TEST
extern int test();
#endif	/*TEST*/
extern KENV kenv;
extern char *findfile();
/**/
cmdxrc(argc,argv,func,name)
int		argc;
char	*argv[];
FUNCP	func;
char	*name;
{
	auto	char	*xfn;
	auto	char	*os;
	auto	char	**xp;
	auto	int		nx;
	auto	int		ix;
/**/
	cmdbig(argc,argv);
/**/
	xfn = findfile(name,3,".",kgetenv("HOME"),kgetenv("DEFAULT"));
/**/
	if(isnull(xfn))	return((*func)(argc,argv));
/**/
	prwho(" <using command file> '%s'\n",xfn);
/**/
	xp = (char **) emalloc( NUMARG * sizeof(char **), "cmdxrc");
/**/
	os = blkrd(xfn);		/* read arg file */
/**/
	strxty(os,LF,' ');		/* LF to blank */
/**/
	xp[0] = argv[0];		/* passged prog name */
	strxty(xp[0],'\\','/');	/* for MSDOS */
	strlwr(xp[0]);			/* for MSDOS */
/**/
	nx = getqs(xp+1,NUMARG-1,os) + 1;	/* parse into words */
/**/
	for(ix = 1; ix < argc && nx < (NUMARG-2) && argv[ix]; ix++)	{
		/* add command line arguments */
		xp[nx] = argv[ix];	
		nx += 1;
		}
	xp[nx++] = NULL;
/**/
	argv = (char **) emalloc( nx * sizeof(char **), "cmdxrc");
	argc = nx - 1;
	memcpy( (char *) argv, (char *) xp, nx * sizeof(char **));
	xp = (char **) free_if( (char *) xp);
/**/
	unlink(xfn);
	xfn = free_if(xfn);
/**/
	if(func != (FUNCP) NULL)	return( (*func)(argc,argv) );
	else						return( argc );
/**/
}
#ifdef	TEST
KENV	kenv;
void
terror(ty)
int		ty;
{
	exit(ty);
}
main(argc,argv)
int		argc;
char	**argv;
{
	exit(cmdxrc(argc,argv,test,"test.xrc"));
}
test(argc,argv)
int		argc;
char	**argv;
{
	auto	int		ix;
	for(ix = 0; ix < argc; ix++)	printf("%d %s\n",ix,argv[ix]);
	return(0);
}
#endif	/*TEST*/
