/*DOSLIB*/
/*UNXLIB*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include	"ksysprot.h"
/*
	make a file zero length WITHOUT changing the
	last modification time or permissions
*/
KENV    kenv;
hint(ty)
int	ty;
{
static	char	*hx[] = {
"=zero [-options] [file(s)]",
"-d        give file current date and time",
"-h        hint",
"-v        verify action",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
/* ### Warning zero.c 22: Function should return a value in function hint === */
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int     argc;
char    *argv[];
{
	auto	int		i;
	kenv.dosdos = isdos();
	disnme(kenv.pname = "zero");
	kenv.flags1 = cmdnum(argc,argv,'d',0,1);
	kenv.prompt = cmdnum(argc,argv,'v',1,0);
/* ### Warning zero.c 37: Call to function 'hint' with no prototype in function main === */
	if(cmdnum(argc,argv,'h',0,1))	exit(hint(0));
	for(i = 1; i < argc; i++)
	if(argv[i] == NULL)		continue;
	else
	if(*argv[i] == '-')		continue;
/* ### Warning zero.c 42: Call to function 'zero' with no prototype in function main === */
	else					zero(argv[i]);
	exit(0);
/* ### Warning zero.c 44: Function should return a value in function main === */
}
zero(is)
char    *is;
{
	static  long        mtime[2];
	extern  long        filemraw();
	extern  long        filesize();
	auto    unsigned    mode;
	auto    int         fd;
	extern	long		time();
	extern	char		*ctime();
	auto	long		now;
	if(*is == '-')  return(ZERO);
	if(filesize(is) == 0L)  {
		printf("z  %s\n",is);
		return(ZERO);
		}
	if(filesize(is) < 0L)   {
/* ### Warning zero.c 62: Call to function 'prterr' with no prototype in function zero === */
		prterr("%s",is);
		return(1);
		}
	if(kenv.prompt)         {
/* ### Warning zero.c 66: Call to function 'ask' with no prototype in function zero === */
		if(ask(is))         return(1);
		}
	mtime[0] = mtime[1] = filemraw(is);
	mode = fileperm(is);
	if(mode < 0)    {
/* ### Warning zero.c 71: Call to function 'prterr' with no prototype in function zero === */
		prterr("m! %s",is);
		return(1);
		}
/* ### Warning zero.c 74: Call to function 'chmod' with no prototype in function zero === */
	if(chmod(is,0777))  {
/* ### Warning zero.c 75: Call to function 'prterr' with no prototype in function zero === */
		prterr("c! %s",is);
		return(1);
		}
/* ### Warning zero.c 78: Call to function 'creat' with no prototype in function zero === */
	fd = creat(is,0);
	if(fd < 0)      {
/* ### Warning zero.c 80: Call to function 'prterr' with no prototype in function zero === */
		prterr("o! %s",is);
		return(1);
		}
	if(kenv.flags1)	{
		time(&now);
		mtime[0] = mtime[1] = now;
		}
/* ### Warning zero.c 87: Call to function 'utime' with no prototype in function zero === */
	if(utime(is,mtime) < 0) {
/* ### Warning zero.c 88: Call to function 'prterr' with no prototype in function zero === */
		prterr("u! %s",is);
		return(3);
		}
/* ### Warning zero.c 91: Call to function 'chmod' with no prototype in function zero === */
	if(chmod(is,mode) < 0)  {
/* ### Warning zero.c 92: Call to function 'prterr' with no prototype in function zero === */
		prterr("m! %s",is);
		return(4);
		}
/* ### Warning zero.c 95: Call to function 'close' with no prototype in function zero === */
	close(fd);
	return(ZERO);
}
ask(is)
char    *is;
{
	auto    char    ls[BUFSIZ];
	for( ; ; )  {
	fputs(is,stdout);
	fputs(" (y or n) ",stdout);
	fflush(stdout);
	gets(ls);
	if(ls[0] == 'y')    return(0);
	else
	if(ls[0] == 'n')    return(1);
	}
}
